#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Sep 15 08:32:46 2021

@author: arb
BY-NC 4.0
réalisé dans la cadre de l'enseignement NSI LLB 22-23'
"""

import pygame

########################################
# Quelues variables utiles pour le jeu #
########################################

VERBOSE = False #a mettre à True pour lire des infos dans la console en mode bavard
N = 8 #nombre de plateaux entre 1 et 8, à modifier pour les tests 
tours = dict()#tours est un dictionnaire contenant trois listes
tours['A'] = [] # cpour l'instant les tours sont vides
tours['B'] = [] 
tours['C'] = []
cpt = 0 # compte le nombre d'étapes


#############################
# Une fonction pour tricher #
#############################

def tricher(n, dep = 'A', inter = 'B', arr = 'C', listeDesCoups=[]):
    '''
    Parameters
    ----------
    n : int
        nombre de disques
    dep : str, optional
        tour de départ. The default is 'A'.
    inter : str, optional
        tour intermédiaire. The default is 'B'.
    arr : str, optional
        tour d'arrivée. The default is 'C'.
    listeDesCoups : liste de tuple, optional
        liste des dépalcements à effectuer. The default is [].

    Returns
    -------
    listeDesCoups : liste de tuple
        liste des déplacements à effectuer.
        le déplacement à l'indexe 0 est le dernier '
    
    >>> tricher(2)
    [('B','C'),('A','C'),('A','B')]
    '''
    listeDesCoups = [('B', 'C'), ('A', 'C'), ('A', 'B')] 
    
    if VERBOSE :
        print(listeDesCoups)
    return listeDesCoups



##########################################
# Les fonctions d'implémentation du jeu  #
#########################################

def initialiser() : #initialise le jeu
    global cpt
    tours['A'] = [ j for j in range(1, N+1) ] # construction de la première pile avec tous les plateaux
    tours['B'] = [] #pour l'instant les deux autres pies sont vides
    tours['C'] = []
    cpt = 0 

def deplacer(pileDepart, pileArrivee) :#déplace le premier disque de la pileDepart vers pileArrivee si cela est possible
    global cpt
    if tours[pileDepart] == [] :
        if VERBOSE :
            print('tour de départ vide')
        rep = False
    elif  tours[pileArrivee] == [] or tours[pileDepart][-1] > tours[pileArrivee][-1] :
        anneau_deplace = tours[pileDepart].pop() #enleve le disque de la pile
        tours[pileArrivee].append(anneau_deplace)# ajoute l'anneau a la pile
        rep = True
        cpt += 1
    else :
        if VERBOSE :
            print('impossible')
        rep = False
    if VERBOSE :
        print(tours)
    return rep

def gagne() : # test si les tours sont en position finale
    rep = False
    if tours['C'] == [j for j in range(1, N+1)] :
        rep = True
    return rep

###########################################
# gestion fenetre graphique et evenements #
###########################################

# définition de la fenêtre du jeu
pygame.init()
ecran = pygame.display.set_mode((931, 550))
pygame.display.set_caption("Les tours de Hanoï NSI LLB 21-22")


#chargement des images 
vignette = pygame.image.load("images/diapo.jpg").convert()

batons = pygame.image.load("images/batons.png").convert()

un = pygame.image.load("images/1.png").convert()
deux = pygame.image.load("images/2.png").convert()
trois = pygame.image.load("images/3.png").convert()
quatre = pygame.image.load("images/4.png").convert()
cinq = pygame.image.load("images/5.png").convert()
six = pygame.image.load("images/6.png").convert()
sept = pygame.image.load("images/7.png").convert()
huit = pygame.image.load("images/8.png").convert()

interdit = pygame.image.load("images/interdit.jpg").convert()
bravo = pygame.image.load("images/bravo.jpg").convert()
fleche = pygame.image.load("images/fleche.jpg").convert()
timg = pygame.image.load("images/t.png").convert()
pygame.display.set_icon(vignette)
#ecran.blit(batons,(0,0))

# Un peu de lecture dans la fenêtre
police = pygame.font.Font(None,30)#taille et police du texte

texte1 = police.render("nombre de déplacements ", True, pygame.Color("#FFFF00"))
texte2 = police.render(str(cpt), True, pygame.Color("#FFFF00"))
textinit=police.render('touche i pour initialiser le jeu', True, pygame.Color("#AAAAAA"))
ecran.blit(textinit, (10, 510))
ecran.blit(texte1, (20, 430))
ecran.blit(texte2, (130, 470))
pygame.display.flip()

def initecran() : # reinitailise l'écran (touche i ou triche)
    pygame.draw.rect(ecran, (255, 255, 255), (0, 0, 931, 50))
    pygame.draw.rect(ecran, (0, 0, 0), (850, 480, 931, 550))
    texte2 = police.render(str(cpt),True,pygame.Color("#FFFF00"))
    pygame.draw.rect(ecran, (0, 0, 0), (100, 450, 90, 60))
    pygame.draw.rect(ecran, (0, 0, 0), (368, 428, 195, 122))
    ecran.blit(texte2, (130, 470))

def affichageTours() : #affiche l'état du jeu
    pygame.draw.rect(ecran, (255, 255, 255), (0, 50, 931, 378)) #on efface l'ecran
    ecran.blit(batons, (0, 50))
    if triche :
        ecran.blit(timg, (850, 480))
    # affichage des tours
    hauteur = 398
    for disque in tours['A'] :
        ecran.blit(dico[disque], (15*disque-2,hauteur))
        hauteur = hauteur-30
     
    hauteur = 398
    for disque in tours['B'] :
        ecran.blit(dico[disque], (15*disque+309, hauteur))
        hauteur = hauteur-30
    
    hauteur = 398
    for disque in tours['C'] :
        ecran.blit(dico[disque], (15*disque+618, hauteur))
        hauteur = hauteur-30
    
    

# On initialise les tours (A contient tous les plateaux)
initialiser() 

dico={1 : un, 2 : deux, 3 : trois, 4 : quatre, 5 : cinq, 6 : six, 7 : sept, 8 : huit} #correspondance valeur des disques : image
posTours={'A' : 138, 'B' : 449 , 'C' : 758} #correspondances entre les tours et leurs abscisses

continuer = True 
action = -1 # 1 : on prend un disque -1 on pose un disque
cpt = 0 # nombre de déplacement effectués
triche = False 
first = True
#################################################################
# La boucle principale qui gère les actions liées aux évènements#
#################################################################
pygame.draw.rect(ecran, (255, 255, 255), (0, 0, 931, 50))
while continuer :
    
    affichageTours()
    # gestion des événements
    #event=pygame.event.wait()
    for event in pygame.event.get() :
        # quitter le jeu
        if event.type == pygame.QUIT:
            continuer = False
        
        if not triche :
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_i:
                    initialiser()
                    initecran()
                    
                if event.key == pygame.K_t:
                    triche = True
                    if VERBOSE:
                        print("triche")
                    initialiser()
                    initecran()
                    solution = tricher(N)
                    first = True# solution est une liste de tuples
                    
            # déplacer un disque
            if event.type == pygame.MOUSEBUTTONUP : # se déclenche par un clic gauche
                action = action * -1 # 1 pour choisir pile de départ -1 pour choisir pile d'arrivée
                if VERBOSE :
                    if action == 1:
                        print('depart')
                    else :
                        print('arivee')
                
                if event.pos[0] < 293:
                    t='A'
                elif event.pos[0] < 603:
                    t='B'
                else :
                    t='C'
                if VERBOSE :
                    print(t)
                    print(event.pos)
                
                if action == 1:
                    pileDepart = t
                    ecran.blit(fleche ,(posTours[t]-16, 00)) #on affiche la fleche
                    if VERBOSE :
                        print(posTours[t]-16, 0)
                else :
                    pileArrivee = t
                    rep = deplacer(pileDepart, pileArrivee)
                    pygame.draw.rect(ecran, (255, 255, 255), (0, 0, 931, 50)) #on efface la fleche
                    if not(rep) :
                        ecran.blit(interdit, (404, 428))
                    else :
                        pygame.draw.rect(ecran, (0, 0, 0), (360, 428, 210, 122))
                        texte2 = police.render(str(cpt), True, pygame.Color("#FFFF00"))
                        pygame.draw.rect(ecran, (0, 0, 0), (100, 450, 100, 60))
                        ecran.blit(texte2, (130, 470))
            
        elif first == False :
            if not(solution == []) :
                event = pygame.event.wait()
                
                while event.type != pygame.KEYDOWN or event.type == pygame.QUIT : #on attend un appuie sur une touche pour continuer la solution
                    event = pygame.event.wait()
                
                if event.type == pygame.QUIT :
                    continuer = False
                    
                
                    
                elif event.key == pygame.K_i:
                    triche = False
                    initialiser()
                    initecran()
                        
                coup = solution.pop() #dernier tuple de la liste solution
                if VERBOSE :
                    print(coup)
                deplacer(coup[0], coup[1]) #deplace le disque de la pile coup[0] vers la pile coup[1]
                # actualisation du nombre de coups utilisés
                pygame.draw.rect(ecran, (0, 0, 0), (404, 428, 122, 122))
                texte2 = police.render(str(cpt), True, pygame.Color("#FFFF00"))
                pygame.draw.rect(ecran, (0, 0, 0), (100, 450, 90, 60))
                ecran.blit(texte2, (130, 470))
                
                
            else :
                triche = False
                first = True
                if VERBOSE :
                    print('triche terminée')
        else :
            first = False
        # fin du jeu ?
        if gagne() :
            pygame.draw.rect(ecran, (0, 0, 0), (368, 428, 931, 500))
            ecran.blit(bravo, (368, 428))
            if cpt == 2**N-1 :
                text3 = police.render("vous avez réalisé le nombre ", True, pygame.Color("#FFFF00"))
                text7 = police.render("minimal de déplacements", True, pygame.Color("#FFFF00"))
                ecran.blit(text3, (580, 430))
                ecran.blit(text7, (580, 460))
                
            else :
                text4 = police.render("Mais vous pouvez faire mieux", True, pygame.Color("#FFFF00"))
                text5 = police.render("une solution existe en", True, pygame.Color("#FFFF00"))
                text6 = police.render(str(2**N-1) + " déplacements", True, pygame.Color("#FFFF00"))
                ecran.blit(text4, (580, 430))
                ecran.blit(text5, (580, 460))
                ecran.blit(text6, (580, 490))
            if VERBOSE :
                print(cpt)
            
            
    
    pygame.display.flip() 
pygame.quit()